/*
++++++++++++++ TWEAKS AND SWITCHES FOR MODS ++++++++++++++
 In this list you can customize the key features of the game to your liking.
 Or disable certain mods completely.

!!!!!!!!!!!!!! WARNING !!!!!!!!!!!!!!
 This is a program file. Changes to the format of the code will mess up the game.
 Please follow these rules when editing settings:
 - Change ONLY the values after the CAPITAL_SETTING names.
 - Use ONLY the values from the explanation below the setting.
 - DO NOT replace numbers with "letters", or integer numbers (1) with decimal values (0.75)
 - NEVER remove a line starting with "#define".
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*/

// LDH mods -->

#define ENHANCED_SAILING_MODE		1		// BOOL - 1 = ON - fore and aft rigged ships sail fastest with wind on the beam
											//    0 is default game
											//    Valid values 0 and 1

#define CREW_ON_DECK                1       // BOOL - 1 = ON - show crewmen on deck in first person view, 0 is default game
											//    Valid values 0 and 1

#define CREW_SAILING_EXP			1		// BOOL - 1 = ON - Crew gets experience for sailing, 0 is default game
											//    Valid values 0 and 1

#define PLAYER_SAILING_EXP			1		// BOOL - 1 = ON - Player gets experience for sailing, 0 is default game
											//    Valid values 0 and 1

#define BI_InterfaceScale           1.2		// FLOAT - 1.2 - set > 1.0 to enlarge interface fonts, 1.0 is default game
											//    Valid values: not checked, 1.0 to 1.5 tested, should be > 0.0

#define CAMERA_SWING_AT_DOORS		0		// BOOL - 0 = OFF - keeps camera from panning out when you're at a door
											//  Camera will still swing on dialogs
											//    1 is default game
											//    Valid values 0 and 1

#define FORCE_STORE_TO_TRADE        0		// BOOL - 0 = OFF - force storekeeper to always trade, never too busy
											//  This is a cheat and recommended only for critical situations
											//    0 is default game
											//    Valid values 0 and 1

#define WDM_SHIP_SPEED              3.0     // FLOAT - 3.0 - ship's apparent speed on world map, 1.0 is default game
											//    Valid values 1.0 to 3.0
											//    Recommended value = 3.0

#define WIND_INCREASE               -1.0    // FLOAT - -1.0 - increase wind speed by this amount, 0.0 is default game
											//    Valid values 0.0 to 10.0, and -1.0
											//    Recommended value = 10.0 or 5.0 if ships are too fast
                                            //    If this number is set to -1.0, the following values will be used instead

                                            //  NOTE: Settng more than 16 knots difference between low and high
                                            //  is allowed, but may produce undesired results at wind extremes
                                            //   unless CLASS_EFFECT_OF_WIND is set very low
#define LOWEST_WIND                 12.0    //  FLOAT - 12.0 - the lowest wind speed you will see (default game 2.0)
											//    Valid values 2.0 to 26.0
											//    Recommended value 12.0

#define HIGHEST_WIND                23.0    // FLOAT - 23.0 - the highest wind speed you will see (default game 18.0)
											//    Valid values 4.0 to 28.0
											//    Recommended value 23.0

#define CLASS_EFFECT_OF_WIND		1.0		// FLOAT - 1.0 - This affects ship speed due to class and wind
											//    Valid values 0.0 to 1.0, 1.0 is stock game, 0.0 disables effect
											//    I use 0.25, lower numbers better if wind speeds are increased
											// No effect at average wind or class 3 ships
											// Average wind is 10 knots in stock game, increases by WIND_INCREASE
											// If WIND_INCREASE is -1, average is average of lowest and highest wind speeds
											// Lower winds,  class 6 ships are faster, class 1 ships are slower
											// Higher winds, class 6 ships are slower, class 1 ships are faster

#define WIND_VARIATION				0.5		// FLOAT - 0.5 - Amount wind direction and speed fluctuates
											//    Valid values 0.0 to 1.0, 1.0 is stock game, 0.0 disables variation

#define CHANGE_WIND_FROM_DOCK		1		// BOOL - 1=ON - If On, allows player to randomize wind up to 5 times
											//	when entring ship from dock. Go back to dock to reset
											//    0 is default game
											//    Valid values 0 and 1

#define CHANGE_WIND_FROM_WDM		1		// BOOL - 1=ON - If On, allows player to reset wind after worldmap
											//	to wind direction before entering world map, works until hour changes
											//    0 is default game
											//    Valid values 0 and 1

#define SORT_PRICELIST              1       // BOOL - 1=ON - If On, sorts the tradebook 
                                            //  pricelist clockwise from Havana to Beliz
											//    0 is default game
											//    Valid values 0 and 1

// LDH mods <--

